# easySwoole
```
  ______                          _____                              _        
 |  ____|                        / ____|                            | |       
 | |__      __ _   ___   _   _  | (___   __      __   ___     ___   | |   ___ 
 |  __|    / _` | / __| | | | |  \___ \  \ \ /\ / /  / _ \   / _ \  | |  / _ \
 | |____  | (_| | \__ \ | |_| |  ____) |  \ V  V /  | (_) | | (_) | | | |  __/
 |______|  \__,_| |___/  \__, | |_____/    \_/\_/    \___/   \___/  |_|  \___|
                          __/ |                                               
                         |___/                                                
```
EasySwoole 是一款基于Swoole Server 开发的常驻内存型PHP框架，专为API而生，摆脱传统PHP运行模式在进程唤起和文件加载上带来的性能损失。EasySwoole 高度封装了Swoole Server 而依旧维持Swoole Server 原有特性，支持同时混合监听HTTP、自定义TCP、UDP协议，让开发者以最低的学习成本和精力编写出多进程，可异步，高可用的应用服务。 

## 特性

- 强大的 TCP/UDP Server 框架，多线程，EventLoop，事件驱动，异步，Worker进程组，Task异步任务，毫秒定时器，SSL/TLS隧道加密
- EventLoop API，让用户可以直接操作底层的事件循环，将socket，stream，管道等Linux文件加入到事件循环中。
## 描述
  把EasySwoole 的核心与配置文件和业务代码分离出来,方便用户进行升级维护 
## 使用方法
    ```
    composer require aprchen/easyswoole_core
    ```
    
   拷贝 App 与 Conf目录到自己的文件夹,
   新建bin目录,新建 server文件,输入以下内容
 
   ```
    #!/usr/local/bin/php
    <?php
    define("ES_ROOT",realpath(__DIR__.'/../src'));
    define("ES_APP",ES_ROOT.'/App');
    define("ES_CONF",ES_ROOT.'/Conf');
    require_once dirname(__FILE__).'/../vendor/easyswoole/easyswoole/src/server';
   ```
  启动
  ```
  php bin\server start
  ```
    
## 其他

- QQ交流群 ： 633921431

- [项目官网与文档](http://www.easyswoole.com/)

- [文档维护地址](https://github.com/kiss291323003/doc-easyswoole) 
    easySwoole采用gitbook作为文档撰写工具，若您在使用过程中，有发现文档需要纠正/补充。请直接提交在github上。
